"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_modules_dest_copy_1 = require("./node-modules-dest-copy");
class NodeModulesBuilder {
    constructor($fs, $injector, $nodeModulesDependenciesBuilder) {
        this.$fs = $fs;
        this.$injector = $injector;
        this.$nodeModulesDependenciesBuilder = $nodeModulesDependenciesBuilder;
    }
    prepareNodeModules(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            const productionDependencies = this.intialPrepareNodeModulesIfRequired(opts);
            const npmPluginPrepare = this.$injector.resolve(node_modules_dest_copy_1.NpmPluginPrepare);
            yield npmPluginPrepare.preparePlugins(productionDependencies, opts.nodeModulesData.platform, opts.nodeModulesData.projectData, opts.nodeModulesData.projectFilesConfig);
        });
    }
    prepareJSNodeModules(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            const productionDependencies = this.intialPrepareNodeModulesIfRequired(opts);
            const npmPluginPrepare = this.$injector.resolve(node_modules_dest_copy_1.NpmPluginPrepare);
            yield npmPluginPrepare.prepareJSPlugins(productionDependencies, opts.nodeModulesData.platform, opts.nodeModulesData.projectData, opts.nodeModulesData.projectFilesConfig);
        });
    }
    intialPrepareNodeModulesIfRequired(opts) {
        const { nodeModulesData } = opts;
        const productionDependencies = this.$nodeModulesDependenciesBuilder.getProductionDependencies(nodeModulesData.projectData.projectDir);
        if (opts.copyNodeModules && !nodeModulesData.appFilesUpdaterOptions.bundle) {
            this.initialPrepareNodeModules(opts, productionDependencies);
        }
        return productionDependencies;
    }
    initialPrepareNodeModules(opts, productionDependencies) {
        const { nodeModulesData, release } = opts;
        if (!this.$fs.exists(nodeModulesData.absoluteOutputPath)) {
            nodeModulesData.lastModifiedTime = null;
        }
        const tnsModulesCopy = this.$injector.resolve(node_modules_dest_copy_1.TnsModulesCopy, {
            outputRoot: nodeModulesData.absoluteOutputPath
        });
        tnsModulesCopy.copyModules({ dependencies: productionDependencies, release });
    }
}
exports.NodeModulesBuilder = NodeModulesBuilder;
$injector.register("nodeModulesBuilder", NodeModulesBuilder);
